<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>WebSockets</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootswatch/4.3.1/superhero/bootstrap.min.css" />
  <script src="https://code.jquery.com/jquery-3.4.1.js"
          integrity="sha256-WpOohJOqMqqyKL9FccASB9O0KwACQJpFTUBLTYOVvVU=" crossorigin="anonymous"></script>
  <link href="https://fonts.googleapis.com/css?family=Roboto+Mono:400,700&display=swap" rel="stylesheet">
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.0/css/all.css"
        integrity="sha384-lZN37f5QGtY3VHgisS14W3ExzMWZxybE1SJSEsQp9S+oqd12jhcu+A56Ebc1zFSJ" crossorigin="anonymous">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.4.4/ace.js"></script>
  <style>
    body {
      font-family: 'Roboto Mono', monospace;
    }
    .ace_editor .ace_marker-layer .ace_bracket { display: none }
    .request-disabled {
      opacity: 0.15;
    }
  </style>
</head>
<body>

  <form class="container pl-5 pr-5 pt-3 pb-3">
    <div id="status" class="text-center pb-3 font-weight-bold">
      &nbsp;
    </div>
    <div class="row">
      <div class="col-6">
        <div class="form-group">
          <input id="url" type="text" placeholder="url" autocomplete="off" class="form-control"/>
        </div>
        <div class="form-group text-center">
          <button id="btn-connect" class="btn btn-success" disabled>Connect</button>
        </div>
        <div class="form-group" id="request-wrapper">
          <div style="min-height: 20em;" id="request"></div>
        </div>
        <div class="form-group text-center">
          <button id="btn-send" class="btn btn-success" disabled>Send</button>
        </div>
        <div class="text-center font-weight-bold">History:</div>
        <div id="history"></div>
      </div>
      <div class="col-6">
        <div class="text-center font-weight-bold">Messages:</div>
        <div id="messages"></div>
      </div>
    </div>
  </form>

  <script>
    var editor = ace.edit("request", {
      mode: "ace/mode/json",
      fontFamily: 'Roboto Mono',
      fontSize: "1em",
      autoScrollEditorIntoView: true,
      minLines: 2,
      useWorker: false,
      tabSize: 2,
      highlightActiveLine: false,
      copyWithEmptySelection: false,
      cursorStyle: "slim",
      displayIndentGuides: false,
      highlightGutterLine: false,
      showGutter: false,
      maxLines: Infinity
    });
    editor.renderer.setScrollMargin(10, 10);
    editorDisabled(true);

    $("#url").val(localStorage.getItem('lastUrl'));
    updateConnectButtonState();
    updateHistory();

    var webSocket;

    $('#url').on("input propertychange", updateConnectButtonState);

    $('#btn-connect').click(function (e) {
      e.preventDefault();

      if (webSocket && webSocket.readyState === WebSocket.OPEN) {
        webSocket.close();
        return;
      }

      var url = $("#url").val();

      if (!/^wss?:\/\/.+/.test(url)) {
        showMessage("Url must start with ws:// or wss://")
        return;
      }

      $('#messages').html("");
      localStorage.setItem('lastUrl', url);

      webSocket = new WebSocket(url);
      webSocket.onopen = function() {
        $('#status')
          .text("Connected")
          .removeClass("text-danger")
          .addClass("text-success");

        $('#request,#btn-send').prop('disabled', false);

        $("#btn-connect")
          .removeClass("btn-success")
          .addClass("btn-danger")
          .text("Close");

        updateUrlState();
        editorDisabled(false);
      };

      webSocket.onclose = function(event) {
        if (event.wasClean) {
          showMessage("Closed");
        } else {
          showError("Connection failed/lost");
        }

        $('#request,#btn-send').prop('disabled', true);

        $("#btn-connect")
          .removeClass("btn-danger")
          .addClass("btn-success")
          .text("Connect");

        updateUrlState();
        editorDisabled(true);
      };

      webSocket.onmessage = function(event) {
        showWebSocketMessage(true, event.data)
      };
    });

    $('#btn-send').click(function (e) {
      e.preventDefault();
      var dataToSend = editor.getValue();
      webSocket.send(dataToSend);
      showWebSocketMessage(false, dataToSend);
      updateHistory(dataToSend);
    });

    function showError(text) {
      $('#status')
        .text(text)
        .removeClass("text-success")
        .addClass("text-danger");
    }
    function showMessage(text) {
      $('#status')
        .text(text)
        .removeClass("text-danger")
        .removeClass("text-success");
    }

    function showWebSocketMessage(isInbound, text) {
      var container = $('#messages');
      container.html(
        "<div class=\"row\">" +
        "  <div class=\"col-1 pt-4\">" +
        "    <i class=\"fas fa-arrow-" + (isInbound ? "down text-info " : "up text-success") + "\"></i>" +
        "  </div>" +
        "  <div class=\"jumbotron p-2 pl-3 pr-3 mb-1 mt-3 col-11\" style='padding-bottom: -1em'>" +
        "    <pre style=\"font-size: 1em; margin-bottom: 0\">" + formatJson(text) + "</pre>" +
        "  </div>" +
        "</div>" +
        container.html()
      );
    }

    function updateConnectButtonState() {
      if ($('#url').val().length > 0) {
        $('#btn-connect').prop('disabled', false);
      } else {
        $('#btn-connect').prop('disabled', true);
      }
    }

    function updateUrlState() {
      if (webSocket && webSocket.readyState === WebSocket.OPEN) {
        $('#url').prop('disabled', true);
      } else {
        $('#url').prop('disabled', false);
      }
    }

    function formatJson(text) {
      try {
        return JSON.stringify(JSON.parse(text), null, 2)
      } catch (e) {
        return text;
      }
    }

    function updateHistory(text) {
      var history;
      try {
        history = JSON.parse(localStorage.getItem("history")) || [];
      } catch (e) {
        history = []
      }

      if (text) {
        var json = formatJson(text);
        if (history.includes(json)) {
          return;
        }
        if (history.length >= 5) {
          history.splice(4);
        }
        history.unshift(json);
      }

      var historyHtml = history.map(function (request, i) {
        return (
          "<div class=\"jumbotron p-2 pl-3 pr-3 mb-1 mt-3\" style=\"cursor: pointer;\"" +
          "     onclick=\"editor.setValue($('#history-" + i + "').html(), 1); " +
          "               window.scrollTo({ top: 0, behavior: 'smooth' });\">" +
          "  <pre id=\"history-" + i + "\" style=\"font-size: 1em; margin-bottom: 0;\">" + request + "</pre>" +
          "</div>"
        );
      }).join('');
      $('#history').html(historyHtml);

      localStorage.setItem("history", JSON.stringify(history));
    }

    function editorDisabled(disable) {
      if (disable) {
        $('#request-wrapper')
          .addClass("request-disabled");
        editor.setReadOnly(true);
      } else {
        $('#request-wrapper')
          .removeClass("request-disabled");
        editor.setReadOnly(false);
      }
    }
  </script>

</body>
</html>